package com.izouma.dingdong.repo;

import com.izouma.dingdong.domain.User;
import com.izouma.dingdong.security.Authority;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Collections;
import java.util.List;

@RunWith(SpringRunner.class)
@SpringBootTest
public class UserRepoTest {
    @Autowired
    private UserRepo userRepo;

    @Test
    public void testUser() {
        User user = User.builder()
                .username("root")
                .password("123")
                .avatar("")
                .authorities(Collections.singleton(Authority.builder().name(Authority.NAMES.ROLE_ADMIN.name()).build()))
                .enabled(true)
                .blacklist(false)
                .build();
        userRepo.save(user);
    }

    @Test
    public void createUser() {

        User user = userRepo.findByUsername("18205083565");
        user.setPassword(new BCryptPasswordEncoder().encode("123"));
        userRepo.save(user);
    }

    @Test
    public void findAllByAuthoritiesContains() {
        List<User> list = userRepo.findAllByAuthoritiesNotContains(Authority.builder().name("ROLE_ADMIN").build());
        System.out.println(list);
    }
}
